/*
    EXIF ReGenerate
    Copyright (C) 2010 - 2011 Ingemar Ceicer
    http://ceicer.org/ingemar/
    programmering1 (at) ceicer (dot) org

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
*/

#ifndef BIGIMAGE_H
#define BIGIMAGE_H

#include <QWidget>
#include <QLabel>
#include <QScrollArea>
#include <QImageReader>
#include <QMenu>

#include "mainwindow.h"
#include "config.h"

namespace Ui {
    class Bigimage;
}

class Bigimage : public QWidget
{
    Q_OBJECT

public:
    explicit Bigimage(QWidget *parent = 0);
    Bigimage(QString);
    ~Bigimage();


private slots:
    void stang();
    void small();
    void normal();
    void large();
    void xLarge();
    void xxLarge();
    void xxxLarge();

    void s1();
    void s1_5();

    void s2();
    void s2_5();
    void s3();
    void s3_5();
    void s4();
    void s4_5();
    void s5();
    void s5_5();
    void s6();
    void s6_5();
    void s7();
    void s7_5();
    void s8();
    void s8_5();

    void s9();
    void s9_5();
    void s10();



private:
    Ui::Bigimage *ui;
    QImageReader *bigImageReader;
    QImage *bigImage;
    QLabel *bigLbl;
    QScrollArea *scrollArea;
    void berakna(QString s, float f_storlek, int i_storlek, float f_magnify, int i_yb_lage, int i_xb_lage);
    Config *k;

    QMenu *menuEnlargedSize;
    QMenu *menuEnlargedDetails;

    //QAction *actionStang;

    QAction *actionSmall;
    QAction *actionNormal;
    QAction *actionLarge;
    QAction *actionXLarge;
    QAction *actionXXLarge;
    QAction *actionXXXLarge;

    const int *xmax;
    const int *ymax;


    QAction *action1;
    QAction *action1_5;
    QAction *action2;
    QAction *action2_5;
    QAction *action3;
    QAction *action3_5;
    QAction *action4;
    QAction *action4_5;
    QAction *action5;
    QAction *action5_5;
    QAction *action6;
    QAction *action6_5;
    QAction *action7;
    QAction *action7_5;
    QAction *action8;
    QAction *action8_5;
    QAction *action9;
    QAction *action9_5;
    QAction *action10;



    QString global_s;
    float global_f_storlek;
    int global_i_storlek;
    float global_f_magnify;
    int global_i_yb_lage;
    int global_i_xb_lage;


   // void resizeEvent(QResizeEvent * event);
void closeEvent ( QCloseEvent * event );


};

#endif // BIGIMAGE_H
