/*
    EXIF ReGenerate
    Copyright (C) 2010 - 2011 Ingemar Ceicer
    http://ceicer.org/ingemar/
    programmering1 (at) ceicer (dot) org

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
*/

#include "mainwindow.h"
#include "bigimage.h"
#include "ui_mainwindow.h"
#include "config.h"





MainWindow::MainWindow(QWidget *parent) :
    QMainWindow(parent),
    ui(new Ui::MainWindow)
{
    ui->setupUi(this);


    // KOLLA SPRKET
    //QString lokal = QLocale::languageToString(QLocale::system().language());
    //QMessageBox::information(this,"TEST",lokal);

    //Kollar om programmet r uppdaterat
    QString conf_file_name = QDir::toNativeSeparators("/"PROG_NAME".conf");
    k = new Config(conf_file_name);
    std::string version = k->getConf("version");

//QMessageBox::information(this,"TEST",QString::fromStdString(version));
    if (version != VERSION)
    {
        if (version == "nothing")
        {
            k->newConf("version",VERSION);
            QMessageBox::information(this,APPLICATION_NAME " " VERSION,APPLICATION_NAME " " +tr(" is updated to version ")  + " " VERSION );

        }

        else
        {
            k->setConf("version",VERSION);
            QMessageBox::information(this,APPLICATION_NAME " " VERSION,APPLICATION_NAME " " +QString::fromStdString(version)+tr(" is updated to version ")  + " " VERSION );
        }


    }


    delete k;

    this->setContextMenuPolicy( Qt::ActionsContextMenu );
    this->addAction( ui->actionOpen );
    this->addAction( ui->actionOpenMore );
    this->addAction( ui->actionApply );
    this->addAction( ui->actionSave );
    this->addAction( ui->actionCloseFiles );
    this->addAction( ui->actionCloseAllFiles );
    this->addAction( ui->actionExit );
    this->addAction( ui->actionSelectAll );
    this->addAction( ui->actionDeSelectAll );
    this->addAction( ui->actionNoToolbar );
    this->addAction( ui->actionIconsOnly );


   ymax = new int (QApplication::desktop()->width());
   xmax = new int(QApplication::desktop()->height());




    setWindowTitle(APPLICATION_NAME " " VERSION);

    this->setFixedSize(431,*xmax-80);


 fileNames = new QStringList;

ui->mainToolBar->addAction(ui->actionOpen);
ui->mainToolBar->addAction(ui->actionOpenMore);

ui->mainToolBar->addAction(ui->actionApply);
ui->mainToolBar->addAction(ui->actionSave);
ui->mainToolBar->addAction(ui->actionCloseFiles);
ui->mainToolBar->addAction(ui->actionCloseAllFiles);
ui->mainToolBar->addAction(ui->actionCloseAllFiles);
ui->mainToolBar->addAction(ui->actionExit);
ui->mainToolBar->addSeparator();
ui->mainToolBar->addAction(ui->actionSelectAll);
ui->mainToolBar->addAction(ui->actionDeSelectAll);

ui->actionSave->setDisabled(true);

 imgLbl = new QLabel[1];
 exifExist = new bool[1];
 exifExist = new bool[1];
 datum = new QDate[1];
 tid = new QTime[1];
 datumTid = new QDateTime[1];
 exifLbl = new QLabel[1];
 checkbox = new QCheckBox[1];
 knapp = new QPushButton[1];
 knappSet = new QPushButton[1];
 signalMapper = new QSignalMapper[1];
 signalMapper2 = new QSignalMapper[1];
 signalMapperSet = new QSignalMapper[1];
 containerLabel = new QLabel;
 scrollArea = new QScrollArea;


    startup_config(); // Kollar vid programstart

    connect(ui->actionExit, SIGNAL(triggered()), this, SLOT(close()));
    connect(ui->actionOpen, SIGNAL(triggered()), this, SLOT(open()));
    connect(ui->actionOpenMore, SIGNAL(triggered()), this, SLOT(openMore()));
    connect(ui->actionApply, SIGNAL(triggered()), this, SLOT(apply()));
    connect(ui->actionSave, SIGNAL(triggered()), this, SLOT(save()));
    connect(ui->actionCloseFiles, SIGNAL(triggered()), this, SLOT(closeFiles()));
    connect(ui->actionCloseAllFiles, SIGNAL(triggered()), this, SLOT(closeAllFiles()));
    connect(ui->actionSelectAll, SIGNAL(triggered()), this, SLOT(selectAll()));
    connect(ui->actionDeSelectAll, SIGNAL(triggered()), this, SLOT(deSelectAll()));
    connect(ui->actionSwedish, SIGNAL(triggered()), this, SLOT(swedish()));
    connect(ui->actionEnglish, SIGNAL(triggered()), this, SLOT(english()));
    connect(ui->actionRussian, SIGNAL(triggered()), this, SLOT(russian()));
    connect(ui->actionGreek, SIGNAL(triggered()), this, SLOT(greek()));

    // View
    connect(ui->actionIconsOnly, SIGNAL(triggered()), this, SLOT(iconsOnly()));
    connect(ui->actionNoToolbar, SIGNAL(triggered()), this, SLOT(noToolbar()));

    // Tools BILDSTORLEK
    connect(ui->actionSmall, SIGNAL(triggered()), this, SLOT(small()));
    connect(ui->actionNormal, SIGNAL(triggered()), this, SLOT(normal()));
    connect(ui->actionLarge, SIGNAL(triggered()), this, SLOT(large()));
    connect(ui->actionXLarge, SIGNAL(triggered()), this, SLOT(xLarge()));
    connect(ui->actionXXLarge, SIGNAL(triggered()), this, SLOT(xxLarge()));
    connect(ui->actionXXXLarge, SIGNAL(triggered()), this, SLOT(xxxLarge()));

    // Tools FRSTORING
    connect(ui->action1, SIGNAL(triggered()), this, SLOT(s1()));
    connect(ui->action1_5, SIGNAL(triggered()), this, SLOT(s1_5()));
    connect(ui->action2, SIGNAL(triggered()), this, SLOT(s2()));
    connect(ui->action2_5, SIGNAL(triggered()), this, SLOT(s2_5()));
    connect(ui->action3, SIGNAL(triggered()), this, SLOT(s3()));
    connect(ui->action3_5, SIGNAL(triggered()), this, SLOT(s3_5()));
    connect(ui->action4, SIGNAL(triggered()), this, SLOT(s4()));
    connect(ui->action4_5, SIGNAL(triggered()), this, SLOT(s4_5()));
    connect(ui->action5, SIGNAL(triggered()), this, SLOT(s5()));
    connect(ui->action5_5, SIGNAL(triggered()), this, SLOT(s5_5()));
    connect(ui->action6, SIGNAL(triggered()), this, SLOT(s6()));
    connect(ui->action6_5, SIGNAL(triggered()), this, SLOT(s6_5()));
    connect(ui->action7, SIGNAL(triggered()), this, SLOT(s7()));
    connect(ui->action7_5, SIGNAL(triggered()), this, SLOT(s7_5()));
    connect(ui->action8, SIGNAL(triggered()), this, SLOT(s8()));
    connect(ui->action8_5, SIGNAL(triggered()), this, SLOT(s8_5()));

    connect(ui->action9, SIGNAL(triggered()), this, SLOT(s9()));
    connect(ui->action9_5, SIGNAL(triggered()), this, SLOT(s9_5()));
    connect(ui->action10, SIGNAL(triggered()), this, SLOT(s10()));

    // TOOLS Delete Personal Settings
    connect(ui->actionDeletePersonalSettings, SIGNAL(triggered()), this, SLOT(deletePersonalSettings()));

    // Tools Set offset
    connect(ui->actionSetOffset, SIGNAL(triggered()), this, SLOT(setOffset()));



    //HELP
    connect(ui->actionCheckForUpdates, SIGNAL(triggered()), this, SLOT(updates()));
    connect(ui->actionAbout, SIGNAL(triggered()), this, SLOT(about()));
    connect(ui->actionAboutQt, SIGNAL(triggered()), this, SLOT(aboutQt()));
    connect(ui->actionHelp, SIGNAL(triggered()), this, SLOT(help()));

    ui->actionOpenMore->setEnabled(false);


}

MainWindow::~MainWindow()
{
    exit_config(); // Lser av konfigurationen vid programslut

    delete[] imgLbl;
    delete[] exifExist;
    delete[] datum;
    delete[] tid;
    delete[] datumTid;
    delete[] exifLbl;
    delete[] checkbox;
    delete[] knapp;
    delete[] knappSet;
    delete[] signalMapper;
    delete[] signalMapper2;
    delete[] signalMapperSet;
    delete containerLabel;
    delete scrollArea;
    delete xmax;
    delete ymax;
close();
    //exit(0);
}


//PRIVATE FUNCTIONS
void MainWindow::startup_config() // Vid programstart
{


    QString conf_file_name = QDir::toNativeSeparators("/"PROG_NAME".conf");
    k = new Config(conf_file_name);
  /*  std::string first = k->getConf("first_time");

    if (first=="1")
    {
        QMessageBox::information(this,APPLICATION_NAME+" "+VERSION,tr("Welcome to ") + APPLICATION_NAME+" "+VERSION );
        k->setConf("first_time","0");

    }
  */
     std::stringstream ss;

     int x_lage=0,y_lage=0;
     std::string initiera;

     initiera = k->getConf("check_onstart");
     if (initiera == "1")
     {
         Update *checkUpdate2 = new Update;
         checkUpdate2->startUppCheck();

     }


        initiera = k->getConf("x_lage");
        ss.clear();
       ss << initiera;
        ss >> x_lage;

        initiera = k->getConf("y_lage");
        ss.clear();
       ss << initiera;
        ss >> y_lage;



        if (y_lage > (*ymax-50))
        {
            y_lage=100;
            x_lage=100;
         }


        if (x_lage > (*xmax-50))
        {
            y_lage=100;
            x_lage=100;
         }


  setGeometry(y_lage,x_lage,431,*xmax-50);

  lblStatus = new QLabel(this);
  lblStatus->setGeometry(10,*xmax-100,400,20);
  QFont font("Helvetica",10);
  lblStatus->setFont(font);
  lblStatus->setText(tr("No files loaded"));
  ui->lblAdjustment->setFont(font);



   initiera = k->getConf("actionSmall");
   if (initiera == "true")
       ui->actionSmall->setChecked(true);
   else
       ui->actionSmall->setChecked(false);

   initiera = k->getConf("actionNormal");
   if (initiera == "true")
       ui->actionNormal->setChecked(true);
   else
       ui->actionNormal->setChecked(false);

   initiera = k->getConf("actionLarge");
   if (initiera == "true")
       ui->actionLarge->setChecked(true);
   else
       ui->actionLarge->setChecked(false);

   initiera = k->getConf("actionXLarge");
   if (initiera == "true")
       ui->actionXLarge->setChecked(true);
   else
       ui->actionXLarge->setChecked(false);

   initiera = k->getConf("actionXXLarge");
   if (initiera == "true")
       ui->actionXXLarge->setChecked(true);
   else
       ui->actionXXLarge->setChecked(false);


initiera = k->getConf("magnify");

if (initiera=="1")
    ui->action1->setChecked(true);

if (initiera=="1.5")
    ui->action1_5->setChecked(true);

if (initiera=="2")
    ui->action2->setChecked(true);

if (initiera=="2_5")
    ui->action2_5->setChecked(true);

if (initiera=="3")
    ui->action3->setChecked(true);

if (initiera=="3.5")
    ui->action3_5->setChecked(true);

if (initiera=="4")
    ui->action4->setChecked(true);

if (initiera=="4.5")
    ui->action4_5->setChecked(true);

if (initiera=="5")
    ui->action5->setChecked(true);

if (initiera=="5.5")
    ui->action5_5->setChecked(true);

if (initiera=="6")
    ui->action6_5->setChecked(true);

if (initiera=="7")
    ui->action7->setChecked(true);

if (initiera=="7.5")
    ui->action7_5->setChecked(true);

if (initiera=="8")
    ui->action8_5->setChecked(true);

if (initiera=="9")
    ui->action9->setChecked(true);

if (initiera=="9.5")
    ui->action9_5->setChecked(true);

if (initiera=="10")
    ui->action10->setChecked(true);

initiera = k->getConf("offset");
displayOffset(initiera);




initiera = k->getConf("toolButtonStyle");



 if (initiera=="none")
 {
     ui->mainToolBar->hide();
     ui->actionIconsOnly->setChecked(false);
     ui->actionNoToolbar->setChecked(true);

 }

 if (initiera=="iconsOnly")
 {
     ui->mainToolBar->show();
     ui->mainToolBar->setToolButtonStyle(Qt::ToolButtonIconOnly);
     ui->actionIconsOnly->setChecked(true);
     ui->actionNoToolbar->setChecked(false);

 }



 if (initiera != "0")
 {

     QString qs_initiera = QString::fromStdString(initiera);

     QString d, h, min, s;
     bool lyckas;
     qint64 qint_initiera = qs_initiera.toLongLong();
    lyckas =  getOffset(qs_initiera, d, h, min, s);





    if (lyckas)
    {
       //ui->lblAdjustment->setText(tr(" Current offset: D: ")+d+tr(", H: ")+h+tr(", M: ")+min+tr(", S: ")+s );
        int id = d.toInt();
        int ih = h.toInt();
        int imin = min.toInt();
        int is = s.toInt();

       if (qint_initiera < 0)
        {
          id=abs(id);
          ih=abs(ih);
          imin=abs(imin);
          is=abs(is);

          d=d.setNum(id);
          h=h.setNum(ih);
          min=min.setNum(imin);
          s=s.setNum(is);

         if (id != 0)
          ui->lblAdjustment->setText(tr("Current offset: - ")+d+tr(" Days and ")+h+":"+min+":"+s+tr(" (h:m:s)"));
         if (id == 0)
             ui->lblAdjustment->setText(tr("Current offset: - ")+h+":"+min+":"+s+tr(" (h:m:s)"));
       }

       if (qint_initiera > 0)
        {


         if (id != 0)
          ui->lblAdjustment->setText(tr("Current offset: + ")+d+tr(" Days and ")+h+":"+min+":"+s+tr(" (h:m:s)"));
         if (id == 0)
             ui->lblAdjustment->setText(tr("Current offset: + ")+h+":"+min+":"+s+tr(" (h:m:s)"));
       }



     }
   else

       QMessageBox::critical(this, APPLICATION_NAME " " VERSION,tr("No offset was calculated"));






 }
 else
    ui->lblAdjustment->setText(tr("Current offset: None"));








}

void MainWindow::exit_config() // Vid programslut
{

    QString conf_file_name = QDir::toNativeSeparators("/"PROG_NAME".conf");
    k = new Config(conf_file_name);

   QRect rect;
   rect=this->geometry();

   int y_lage=rect.x();
   int x_lage=rect.y();

   std::stringstream ss;
   std::string str;

   ss.clear();

   ss << x_lage;
   ss >> str;
   k->setConf("x_lage",str);

   ss.clear();

   ss << y_lage;
   ss >> str;
   k->setConf("y_lage",str);

   delete k;



}


//SLOTS



void MainWindow::setOffset()
{
    Offset *offset = new Offset;
    offset->show();

}

void MainWindow::help()
{
Help *help = new Help;
help->show();
}


void MainWindow::iconsOnly()
{
if (ui->mainToolBar->isHidden())
    {
    ui->mainToolBar->show();
    ui->mainToolBar->setToolButtonStyle(Qt::ToolButtonIconOnly);


   // Windows
   // scrollArea->setGeometry(1,105,430,*xmax-205);
   // Linux
      scrollArea->setGeometry(1,113,430,*xmax-213);


    QString conf_file_name = QDir::toNativeSeparators("/"PROG_NAME".conf");
    k = new Config(conf_file_name);
    k->setConf("toolButtonStyle","iconsOnly");
    delete k;

    ui->actionNoToolbar->setChecked(false);
    }
    ui->actionIconsOnly->setChecked(true);

}

void MainWindow::noToolbar()
{
if (ui->mainToolBar->isVisible())
    {
        ui->mainToolBar->hide();
    // Windows
    // scrollArea->setGeometry(1,69,430,*xmax-169);
    // Linux
       scrollArea->setGeometry(1,75,430,*xmax-175);
        QString conf_file_name = QDir::toNativeSeparators("/"PROG_NAME".conf");
        k = new Config(conf_file_name);
        k->setConf("toolButtonStyle","none");
        delete k;
        ui->actionIconsOnly->setChecked(false);

    }
ui->actionNoToolbar->setChecked(true);
}

void MainWindow::deletePersonalSettings()
{

    switch(QMessageBox::question(this, APPLICATION_NAME " " VERSION,
                                tr("Do you want to remove your personal settings?\nThis is an appropriate action if you like to uninstall this application.\n")+APPLICATION_NAME+" "+VERSION+tr(" will exit after your personal data is deleted."),
                                tr("Yes"),
                                tr("No"), 0,2))
{
    case 0:
{
Createuser *cr = new Createuser;

if (cr->removeDir())
    {
    QMessageBox::information(this, APPLICATION_NAME " " VERSION,tr("Your personal settings are deleted and\n ")+APPLICATION_NAME+" "+VERSION+tr(" will exit"));
    delete cr;
    exit(0);

    }
else
    QMessageBox::information(this, APPLICATION_NAME " " VERSION,tr("Your personal settings cannot be found.\nNew settings will be saved then you restart the program."));

delete cr;
    break;
}
default:

    break;
    }




}

void MainWindow::about()
{
const QString license = tr("Licensierat under GNU General Public License This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version ")+ LICENCE_VERSION +tr(" of the License, or (at your option) any later version. This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details. You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA.");
QString s;
QList<QByteArray> list;
list = QImageReader::supportedImageFormats();
QList<QByteArray>::const_iterator i;
for (i = list.constBegin(); i != list.constEnd(); ++i)
s = s +" *."+ *i;
QString conf_file_name = QDir::toNativeSeparators("/"PROG_NAME".conf");
k = new Config(conf_file_name);
std::string language = k->getConf("language");
delete k;

QString applicationHomepage;
if (language == "sv_SE")
    applicationHomepage = APPLICATION_HOMEPAGE;
else
    applicationHomepage = APPLICATION_HOMEPAGE_ENG;

QString auther = tr("<br><font color=\"green\" size=\"3\"><b>Copyright &copy; 2010 - ") + CURRENT_YEAR +" "+ PROGRAMMER_NAME + "<br><a href="+applicationHomepage+">"+APPLICATION_NAME+tr(" homepage")+"</a><br>"+PROGRAMMER_EMAIL+"<br>"+tr("Phone: ")+ PROGRAMMER_PHONE+"</b></font><br><br>";

QMessageBox::about(this, tr("About ")+APPLICATION_NAME+" "+VERSION,tr(
                         "<h1><font color=\"#009900\">")+APPLICATION_NAME+" "+VERSION+"</h1>"+auther+tr("A small program to change time data in image files.")+"<br><br>"+tr("Many thanks to Ivan Dolgov for the Russian translation.")+"<br>"+tr("Many thanks to geogeo (www.geogeo.gr) for the Greek translation.")+"<br><br>"+tr("The program can display images in these formats:<br>")+s+tr("<br>Many more file formats that contains exif data can be changed.<br><br>")+license);
}

void MainWindow::aboutQt()
{

 QMessageBox::aboutQt(this,APPLICATION_NAME " " VERSION);

}
void MainWindow::save()
{
    int antal = fileNames->count()-1;

    if (antal > 0)
    {
    std::stringstream ss;
    qint64 offset=0;
    QDateTime dtTmp;
    QString conf_file_name = QDir::toNativeSeparators("/"PROG_NAME".conf");
    k = new Config(conf_file_name);
    std::string stds_offset = k->getConf("offset");
    delete k;
    ss.clear();
    ss << stds_offset;
    ss >> offset;

    char *hittat = new char[20];
    char *info = new char[50];
    char *fnamn = new char[300];

    QString s;
    bool b=true;
    Exifw *exw = new Exifw;
    std::string stds;

    for (int i=0; i<antal; i++)
    {
if (exifExist[i])
        {
    s = QDir::toNativeSeparators(fileNames->at(i+1));
   // QMessageBox::information(this, APPLICATION_NAME+" "+VERSION,s);
    stds=s.toStdString();
    strcpy(fnamn,stds.c_str());

    dtTmp = datumTid[i].addSecs(offset);

    s = dtTmp.toString("yyyyMMddhhmmss");
    stds=s.toStdString();
    strcpy(hittat,stds.c_str());

    b = exw->setExif(fnamn, hittat, info);
    if (b == false)
    {
    s = QString::fromLatin1(info);
    QMessageBox::information(this, APPLICATION_NAME " " VERSION,s);
    b = true;
    }

}
// ipac
ui->progressBar->setValue(i+1);
}
    ui->actionSave->setDisabled(true);
    delete exw;
}
}
void MainWindow::apply()
{
    int antal = fileNames->count()-1;
//QString S;
//S.setNum(antal);
 //QMessageBox::information(this, APPLICATION_NAME+" "+VERSION,S);


    QFont font("Helvetica",10);
    std::stringstream ss;
    qint64 offset=0;
    QDateTime dtTmp;
    QString conf_file_name = QDir::toNativeSeparators("/"PROG_NAME".conf");
    k = new Config(conf_file_name);
    std::string stds_offset = k->getConf("offset");
    delete k;
displayOffset(stds_offset);


if (antal > 0)
{


    ss.clear();
    ss << stds_offset;
    ss >> offset;

    for (int i=0; i<antal; i++)
    {
        if (exifExist[i])
        {
        dtTmp = datumTid[i].addSecs(offset);
        exifLbl[i].setFont(font);
        exifLbl[i].setText(dtTmp.toString("yyyy-MM-dd\nhh:mm:ss"));

        }

    }

         ui->actionSave->setEnabled(true);
 }
}

void MainWindow::updates()
{


      Update *checkUpdate = new Update;
      checkUpdate->startUpdate();
      checkUpdate->exec();

}

void MainWindow::s1()
{
    ui->action1->setChecked(true);
    ui->action1_5->setChecked(false);
    ui->action2->setChecked(false);
    ui->action2_5->setChecked(false);
    ui->action3->setChecked(false);
    ui->action3_5->setChecked(false);
    ui->action4->setChecked(false);
    ui->action4_5->setChecked(false);
    ui->action5->setChecked(false);
    ui->action5_5->setChecked(false);
    ui->action6->setChecked(false);
    ui->action6_5->setChecked(false);
    ui->action7->setChecked(false);
    ui->action7_5->setChecked(false);
    ui->action8->setChecked(false);
    ui->action8_5->setChecked(false);
    ui->action9->setChecked(false);
    ui->action9_5->setChecked(false);
    ui->action10->setChecked(false);


    QString conf_file_name = QDir::toNativeSeparators("/"PROG_NAME".conf");
    k = new Config(conf_file_name);
    k->setConf("magnify","1");
    delete k;

}
void MainWindow::s1_5()
{
    ui->action1->setChecked(false);
    ui->action1_5->setChecked(true);
    ui->action2->setChecked(false);
    ui->action2_5->setChecked(false);
    ui->action3->setChecked(false);
    ui->action3_5->setChecked(false);
    ui->action4->setChecked(false);
    ui->action4_5->setChecked(false);
    ui->action5->setChecked(false);
    ui->action5_5->setChecked(false);
    ui->action6->setChecked(false);
    ui->action6_5->setChecked(false);
    ui->action7->setChecked(false);
    ui->action7_5->setChecked(false);
    ui->action8->setChecked(false);
    ui->action8_5->setChecked(false);
    ui->action9->setChecked(false);
    ui->action9_5->setChecked(false);
    ui->action10->setChecked(false);


    QString conf_file_name = QDir::toNativeSeparators("/"PROG_NAME".conf");
    k = new Config(conf_file_name);
    k->setConf("magnify","1.5");
    delete k;

}
void MainWindow::s2()
{
    ui->action1->setChecked(false);
    ui->action1_5->setChecked(false);
    ui->action2->setChecked(true);
    ui->action2_5->setChecked(false);
    ui->action3->setChecked(false);
    ui->action3_5->setChecked(false);
    ui->action4->setChecked(false);
    ui->action4_5->setChecked(false);
    ui->action5->setChecked(false);
    ui->action5_5->setChecked(false);
    ui->action6->setChecked(false);
    ui->action6_5->setChecked(false);
    ui->action7->setChecked(false);
    ui->action7_5->setChecked(false);
    ui->action8->setChecked(false);
    ui->action8_5->setChecked(false);
    ui->action9->setChecked(false);
    ui->action9_5->setChecked(false);
    ui->action10->setChecked(false);


    QString conf_file_name = QDir::toNativeSeparators("/"PROG_NAME".conf");
    k = new Config(conf_file_name);
    k->setConf("magnify","2");
    delete k;

}
void MainWindow::s2_5()
{
    ui->action1->setChecked(false);
    ui->action1_5->setChecked(false);
    ui->action2->setChecked(false);
    ui->action2_5->setChecked(true);
    ui->action3->setChecked(false);
    ui->action3_5->setChecked(false);
    ui->action4->setChecked(false);
    ui->action4_5->setChecked(false);
    ui->action5->setChecked(false);
    ui->action5_5->setChecked(false);
    ui->action6->setChecked(false);
    ui->action6_5->setChecked(false);
    ui->action7->setChecked(false);
    ui->action7_5->setChecked(false);
    ui->action8->setChecked(false);
    ui->action8_5->setChecked(false);
    ui->action9->setChecked(false);
    ui->action9_5->setChecked(false);
    ui->action10->setChecked(false);


    QString conf_file_name = QDir::toNativeSeparators("/"PROG_NAME".conf");
    k = new Config(conf_file_name);
    k->setConf("magnify","2.5");
    delete k;

}
void MainWindow::s3()
{
    ui->action1->setChecked(false);
    ui->action1_5->setChecked(false);
    ui->action2->setChecked(false);
    ui->action2_5->setChecked(false);
    ui->action3->setChecked(true);
    ui->action3_5->setChecked(false);
    ui->action4->setChecked(false);
    ui->action4_5->setChecked(false);
    ui->action5->setChecked(false);
    ui->action5_5->setChecked(false);
    ui->action6->setChecked(false);
    ui->action6_5->setChecked(false);
    ui->action7->setChecked(false);
    ui->action7_5->setChecked(false);
    ui->action8->setChecked(false);
    ui->action8_5->setChecked(false);
    ui->action9->setChecked(false);
    ui->action9_5->setChecked(false);
    ui->action10->setChecked(false);


    QString conf_file_name = QDir::toNativeSeparators("/"PROG_NAME".conf");
    k = new Config(conf_file_name);
    k->setConf("magnify","3");
    delete k;

}
void MainWindow::s3_5()
{
    ui->action1->setChecked(false);
    ui->action1_5->setChecked(false);
    ui->action2->setChecked(false);
    ui->action2_5->setChecked(false);
    ui->action3->setChecked(false);
    ui->action3_5->setChecked(true);
    ui->action4->setChecked(false);
    ui->action4_5->setChecked(false);
    ui->action5->setChecked(false);
    ui->action5_5->setChecked(false);
    ui->action6->setChecked(false);
    ui->action6_5->setChecked(false);
    ui->action7->setChecked(false);
    ui->action7_5->setChecked(false);
    ui->action8->setChecked(false);
    ui->action8_5->setChecked(false);
    ui->action9->setChecked(false);
    ui->action9_5->setChecked(false);
    ui->action10->setChecked(false);


    QString conf_file_name = QDir::toNativeSeparators("/"PROG_NAME".conf");
    k = new Config(conf_file_name);
    k->setConf("magnify","3.5");
    delete k;

}
void MainWindow::s4()
{
    ui->action1->setChecked(false);
    ui->action1_5->setChecked(false);
    ui->action2->setChecked(false);
    ui->action2_5->setChecked(false);
    ui->action3->setChecked(false);
    ui->action3_5->setChecked(false);
    ui->action4->setChecked(true);
    ui->action4_5->setChecked(false);
    ui->action5->setChecked(false);
    ui->action5_5->setChecked(false);
    ui->action6->setChecked(false);
    ui->action6_5->setChecked(false);
    ui->action7->setChecked(false);
    ui->action7_5->setChecked(false);
    ui->action8->setChecked(false);
    ui->action8_5->setChecked(false);
    ui->action9->setChecked(false);
    ui->action9_5->setChecked(false);
    ui->action10->setChecked(false);


    QString conf_file_name = QDir::toNativeSeparators("/"PROG_NAME".conf");
    k = new Config(conf_file_name);
    k->setConf("magnify","4");
    delete k;

}
void MainWindow::s4_5()
{
    ui->action1->setChecked(false);
    ui->action1_5->setChecked(false);
    ui->action2->setChecked(false);
    ui->action2_5->setChecked(false);
    ui->action3->setChecked(false);
    ui->action3_5->setChecked(false);
    ui->action4->setChecked(false);
    ui->action4_5->setChecked(true);
    ui->action5->setChecked(false);
    ui->action5_5->setChecked(false);
    ui->action6->setChecked(false);
    ui->action6_5->setChecked(false);
    ui->action7->setChecked(false);
    ui->action7_5->setChecked(false);
    ui->action8->setChecked(false);
    ui->action8_5->setChecked(false);
    ui->action9->setChecked(false);
    ui->action9_5->setChecked(false);
    ui->action10->setChecked(false);


    QString conf_file_name = QDir::toNativeSeparators("/"PROG_NAME".conf");
    k = new Config(conf_file_name);
    k->setConf("magnify","4.5");
    delete k;

}
void MainWindow::s5()
{
    ui->action1->setChecked(false);
    ui->action1_5->setChecked(false);
    ui->action2->setChecked(false);
    ui->action2_5->setChecked(false);
    ui->action3->setChecked(false);
    ui->action3_5->setChecked(false);
    ui->action4->setChecked(false);
    ui->action4_5->setChecked(false);
    ui->action5->setChecked(true);
    ui->action5_5->setChecked(false);
    ui->action6->setChecked(false);
    ui->action6_5->setChecked(false);
    ui->action7->setChecked(false);
    ui->action7_5->setChecked(false);
    ui->action8->setChecked(false);
    ui->action8_5->setChecked(false);
    ui->action9->setChecked(false);
    ui->action9_5->setChecked(false);
    ui->action10->setChecked(false);


    QString conf_file_name = QDir::toNativeSeparators("/"PROG_NAME".conf");
    k = new Config(conf_file_name);
    k->setConf("magnify","5");
    delete k;

}
void MainWindow::s5_5()
{
    ui->action1->setChecked(false);
    ui->action1_5->setChecked(false);
    ui->action2->setChecked(false);
    ui->action2_5->setChecked(false);
    ui->action3->setChecked(false);
    ui->action3_5->setChecked(false);
    ui->action4->setChecked(false);
    ui->action4_5->setChecked(false);
    ui->action5->setChecked(false);
    ui->action5_5->setChecked(true);
    ui->action6->setChecked(false);
    ui->action6_5->setChecked(false);
    ui->action7->setChecked(false);
    ui->action7_5->setChecked(false);
    ui->action8->setChecked(false);
    ui->action8_5->setChecked(false);
    ui->action9->setChecked(false);
    ui->action9_5->setChecked(false);
    ui->action10->setChecked(false);


    QString conf_file_name = QDir::toNativeSeparators("/"PROG_NAME".conf");
    k = new Config(conf_file_name);
    k->setConf("magnify","5.5");
    delete k;

}
void MainWindow::s6()
{
    ui->action1->setChecked(false);
    ui->action1_5->setChecked(false);
    ui->action2->setChecked(false);
    ui->action2_5->setChecked(false);
    ui->action3->setChecked(false);
    ui->action3_5->setChecked(false);
    ui->action4->setChecked(false);
    ui->action4_5->setChecked(false);
    ui->action5->setChecked(false);
    ui->action5_5->setChecked(false);
    ui->action6->setChecked(true);
    ui->action6_5->setChecked(false);
    ui->action7->setChecked(false);
    ui->action7_5->setChecked(false);
    ui->action8->setChecked(false);
    ui->action8_5->setChecked(false);
    ui->action9->setChecked(false);
    ui->action9_5->setChecked(false);
    ui->action10->setChecked(false);


    QString conf_file_name = QDir::toNativeSeparators("/"PROG_NAME".conf");
    k = new Config(conf_file_name);
    k->setConf("magnify","6");
    delete k;

}
void MainWindow::s6_5()
{
    ui->action1->setChecked(false);
    ui->action1_5->setChecked(false);
    ui->action2->setChecked(false);
    ui->action2_5->setChecked(false);
    ui->action3->setChecked(false);
    ui->action3_5->setChecked(false);
    ui->action4->setChecked(false);
    ui->action4_5->setChecked(false);
    ui->action5->setChecked(false);
    ui->action5_5->setChecked(false);
    ui->action6->setChecked(false);
    ui->action6_5->setChecked(true);
    ui->action7->setChecked(false);
    ui->action7_5->setChecked(false);
    ui->action8->setChecked(false);
    ui->action8_5->setChecked(false);
    ui->action9->setChecked(false);
    ui->action9_5->setChecked(false);
    ui->action10->setChecked(false);


    QString conf_file_name = QDir::toNativeSeparators("/"PROG_NAME".conf");
    k = new Config(conf_file_name);
    k->setConf("magnify","6.5");
    delete k;

}
void MainWindow::s7()
{
    ui->action1->setChecked(false);
    ui->action1_5->setChecked(false);
    ui->action2->setChecked(false);
    ui->action2_5->setChecked(false);
    ui->action3->setChecked(false);
    ui->action3_5->setChecked(false);
    ui->action4->setChecked(false);
    ui->action4_5->setChecked(false);
    ui->action5->setChecked(false);
    ui->action5_5->setChecked(false);
    ui->action6->setChecked(false);
    ui->action6_5->setChecked(false);
    ui->action7->setChecked(true);
    ui->action7_5->setChecked(false);
    ui->action8->setChecked(false);
    ui->action8_5->setChecked(false);
    ui->action9->setChecked(false);
    ui->action9_5->setChecked(false);
    ui->action10->setChecked(false);


    QString conf_file_name = QDir::toNativeSeparators("/"PROG_NAME".conf");
    k = new Config(conf_file_name);
    k->setConf("magnify","7");
    delete k;

}
void MainWindow::s7_5()
{
    ui->action1->setChecked(false);
    ui->action1_5->setChecked(false);
    ui->action2->setChecked(false);
    ui->action2_5->setChecked(false);
    ui->action3->setChecked(false);
    ui->action3_5->setChecked(false);
    ui->action4->setChecked(false);
    ui->action4_5->setChecked(false);
    ui->action5->setChecked(false);
    ui->action5_5->setChecked(false);
    ui->action6->setChecked(false);
    ui->action6_5->setChecked(false);
    ui->action7->setChecked(false);
    ui->action7_5->setChecked(true);
    ui->action8->setChecked(false);
    ui->action8_5->setChecked(false);
    ui->action9->setChecked(false);
    ui->action9_5->setChecked(false);
    ui->action10->setChecked(false);


    QString conf_file_name = QDir::toNativeSeparators("/"PROG_NAME".conf");
    k = new Config(conf_file_name);
    k->setConf("magnify","7.5");
    delete k;

}
void MainWindow::s8()
{
    ui->action1->setChecked(false);
    ui->action1_5->setChecked(false);
    ui->action2->setChecked(false);
    ui->action2_5->setChecked(false);
    ui->action3->setChecked(false);
    ui->action3_5->setChecked(false);
    ui->action4->setChecked(false);
    ui->action4_5->setChecked(false);
    ui->action5->setChecked(false);
    ui->action5_5->setChecked(false);
    ui->action6->setChecked(false);
    ui->action6_5->setChecked(false);
    ui->action7->setChecked(false);
    ui->action7_5->setChecked(false);
    ui->action8->setChecked(true);
    ui->action8_5->setChecked(false);
    ui->action9->setChecked(false);
    ui->action9_5->setChecked(false);
    ui->action10->setChecked(false);

    QString conf_file_name = QDir::toNativeSeparators("/"PROG_NAME".conf");
    k = new Config(conf_file_name);
    k->setConf("magnify","8");
    delete k;

}
void MainWindow::s8_5()
{
    ui->action1->setChecked(false);
    ui->action1_5->setChecked(false);
    ui->action2->setChecked(false);
    ui->action2_5->setChecked(false);
    ui->action3->setChecked(false);
    ui->action3_5->setChecked(false);
    ui->action4->setChecked(false);
    ui->action4_5->setChecked(false);
    ui->action5->setChecked(false);
    ui->action5_5->setChecked(false);
    ui->action6->setChecked(false);
    ui->action6_5->setChecked(false);
    ui->action7->setChecked(false);
    ui->action7_5->setChecked(false);
    ui->action8->setChecked(false);
    ui->action8_5->setChecked(true);
    ui->action9->setChecked(false);
    ui->action9_5->setChecked(false);
    ui->action10->setChecked(false);


    QString conf_file_name = QDir::toNativeSeparators("/"PROG_NAME".conf");
    k = new Config(conf_file_name);
    k->setConf("magnify","8.5");
    delete k;

}



void MainWindow::s9()
{
    ui->action1->setChecked(false);
    ui->action1_5->setChecked(false);
    ui->action2->setChecked(false);
    ui->action2_5->setChecked(false);
    ui->action3->setChecked(false);
    ui->action3_5->setChecked(false);
    ui->action4->setChecked(false);
    ui->action4_5->setChecked(false);
    ui->action5->setChecked(false);
    ui->action5_5->setChecked(false);
    ui->action6->setChecked(false);
    ui->action6_5->setChecked(false);
    ui->action7->setChecked(false);
    ui->action7_5->setChecked(false);
    ui->action8->setChecked(false);
    ui->action8_5->setChecked(false);
    ui->action9->setChecked(true);
    ui->action9_5->setChecked(false);
    ui->action10->setChecked(false);


    QString conf_file_name = QDir::toNativeSeparators("/"PROG_NAME".conf");
    k = new Config(conf_file_name);
    k->setConf("magnify","9");
    delete k;

}
void MainWindow::s9_5()
{
    ui->action1->setChecked(false);
    ui->action1_5->setChecked(false);
    ui->action2->setChecked(false);
    ui->action2_5->setChecked(false);
    ui->action3->setChecked(false);
    ui->action3_5->setChecked(false);
    ui->action4->setChecked(false);
    ui->action4_5->setChecked(false);
    ui->action5->setChecked(false);
    ui->action5_5->setChecked(false);
    ui->action6->setChecked(false);
    ui->action6_5->setChecked(false);
    ui->action7->setChecked(false);
    ui->action7_5->setChecked(false);
    ui->action8->setChecked(false);
    ui->action8_5->setChecked(false);
    ui->action9->setChecked(false);
    ui->action9_5->setChecked(true);
    ui->action10->setChecked(false);


    QString conf_file_name = QDir::toNativeSeparators("/"PROG_NAME".conf");
    k = new Config(conf_file_name);
    k->setConf("magnify","9.5");
    delete k;

}
void MainWindow::s10()
{
    ui->action1->setChecked(false);
    ui->action1_5->setChecked(false);
    ui->action2->setChecked(false);
    ui->action2_5->setChecked(false);
    ui->action3->setChecked(false);
    ui->action3_5->setChecked(false);
    ui->action4->setChecked(false);
    ui->action4_5->setChecked(false);
    ui->action5->setChecked(false);
    ui->action5_5->setChecked(false);
    ui->action6->setChecked(false);
    ui->action6_5->setChecked(false);
    ui->action7->setChecked(false);
    ui->action7_5->setChecked(false);
    ui->action8->setChecked(false);
    ui->action8_5->setChecked(false);
    ui->action9->setChecked(false);
    ui->action9_5->setChecked(false);
    ui->action10->setChecked(true);


    QString conf_file_name = QDir::toNativeSeparators("/"PROG_NAME".conf");
    k = new Config(conf_file_name);
    k->setConf("magnify","10");
    delete k;

}




void MainWindow::small()
{
    ui->actionSmall->setChecked(true);
    ui->actionNormal->setChecked(false);
    ui->actionLarge->setChecked(false);
    ui->actionXLarge->setChecked(false);
    ui->actionXXLarge->setChecked(false);
    ui->actionXXXLarge->setChecked(false);
    QString conf_file_name = QDir::toNativeSeparators("/"PROG_NAME".conf");
    k = new Config(conf_file_name);
    k->setConf("actionSmall","true");
    k->setConf("actionNormal","false");
    k->setConf("actionLarge","false");
    k->setConf("actionXLarge","false");
    k->setConf("actionXXLarge","false");
    k->setConf("actionXXXLarge","false");
    k->setConf("storlek","400");
    delete k;

}
void MainWindow::normal()
{
    ui->actionSmall->setChecked(false);
    ui->actionNormal->setChecked(true);
    ui->actionLarge->setChecked(false);
    ui->actionXLarge->setChecked(false);
    ui->actionXXLarge->setChecked(false);
    ui->actionXXXLarge->setChecked(false);
    QString conf_file_name = QDir::toNativeSeparators("/"PROG_NAME".conf");
    k = new Config(conf_file_name);
    k->setConf("actionSmall","false");
    k->setConf("actionNormal","true");
    k->setConf("actionLarge","false");
    k->setConf("actionXLarge","false");
    k->setConf("actionXXLarge","false");
    k->setConf("actionXXXLarge","false");
    k->setConf("storlek","600");
    delete k;

}
void MainWindow::large()
{
    ui->actionSmall->setChecked(false);
    ui->actionNormal->setChecked(false);
    ui->actionLarge->setChecked(true);
    ui->actionXLarge->setChecked(false);
    ui->actionXXLarge->setChecked(false);
    ui->actionXXXLarge->setChecked(false);
    QString conf_file_name = QDir::toNativeSeparators("/"PROG_NAME".conf");
    k = new Config(conf_file_name);
    k->setConf("actionSmall","false");
    k->setConf("actionNormal","false");
    k->setConf("actionLarge","true");
    k->setConf("actionXLarge","false");
    k->setConf("actionXXLarge","false");
    k->setConf("actionXXXLarge","false");
    k->setConf("storlek","800");
    delete k;

}
void MainWindow::xLarge()
{
    ui->actionSmall->setChecked(false);
    ui->actionNormal->setChecked(false);
    ui->actionLarge->setChecked(false);
    ui->actionXLarge->setChecked(true);
    ui->actionXXLarge->setChecked(false);
    ui->actionXXXLarge->setChecked(false);
    QString conf_file_name = QDir::toNativeSeparators("/"PROG_NAME".conf");
    k = new Config(conf_file_name);
    k->setConf("actionSmall","false");
    k->setConf("actionNormal","false");
    k->setConf("actionLarge","false");
    k->setConf("actionXLarge","true");
    k->setConf("actionXXLarge","false");
    k->setConf("actionXXXLarge","false");
    k->setConf("storlek","1000");
    delete k;

}
void MainWindow::xxLarge()
{
    ui->actionSmall->setChecked(false);
    ui->actionNormal->setChecked(false);
    ui->actionLarge->setChecked(false);
    ui->actionXLarge->setChecked(false);
    ui->actionXXLarge->setChecked(true);
    ui->actionXXXLarge->setChecked(false);
    QString conf_file_name = QDir::toNativeSeparators("/"PROG_NAME".conf");
    k = new Config(conf_file_name);
    k->setConf("actionSmall","false");
    k->setConf("actionNormal","false");
    k->setConf("actionLarge","false");
    k->setConf("actionXLarge","false");
    k->setConf("actionXXLarge","true");
    k->setConf("actionXXXLarge","false");
    k->setConf("storlek","1200");
    delete k;

}

void MainWindow::xxxLarge()
{
    ui->actionSmall->setChecked(false);
    ui->actionNormal->setChecked(false);
    ui->actionLarge->setChecked(false);
    ui->actionXLarge->setChecked(false);
    ui->actionXXLarge->setChecked(false);
    ui->actionXXXLarge->setChecked(true);
    QString conf_file_name = QDir::toNativeSeparators("/"PROG_NAME".conf");
    k = new Config(conf_file_name);
    k->setConf("actionSmall","false");
    k->setConf("actionNormal","false");
    k->setConf("actionLarge","false");
    k->setConf("actionXLarge","false");
    k->setConf("actionXXLarge","false");
    k->setConf("actionXXXLarge","true");
    k->setConf("storlek","1400");
    delete k;

}



void MainWindow::open()
{


open2(false);


}

void MainWindow::openMore()
{


open2(true);


}

void MainWindow::set(const int i)
{


 QString s = QDir::toNativeSeparators(fileNames->at(i+1));
 // QMessageBox::information(this, APPLICATION_NAME+" "+VERSION,tmp);

 Settime *settime = new Settime(s, datum[i],tid[i]);
 settime->exec();

}


void MainWindow::select(const int i)
{

    QString tmp = QDir::toNativeSeparators(fileNames->at(i+1));
  Bigimage *b = new Bigimage(tmp);

    b->show();

}



void MainWindow::check(const int i)
{



  // QString s("GGGG");
//s.setNum(i);

//QMessageBox::information(this, APPLICATION_NAME+" "+VERSION,s);





}

void MainWindow::closeFiles()
{



//QString s;

int antal=fileNames->count();
antal--;
//s.setNum(antal);
//QMessageBox::information(this, APPLICATION_NAME+" "+VERSION,s);
if (antal < 1)
        return;


int i=0;
QStringList::Iterator it = fileNames->begin();
it++;

//QString s;
QStringList stlist;
stlist << "STOP";
//QMessageBox::information(this, APPLICATION_NAME+" "+VERSION,"HIT");

 while (it != fileNames->end())
    {

     if (checkbox[i].isChecked() == false)
        {



         if (*it != "STOP")
         {
            stlist << *it;


        }




        }
it++;
i++;

    }

 delete fileNames;
 fileNames = new QStringList;
 *fileNames=stlist;


int antal2=fileNames->count();
antal2--;
if (antal==antal2)
{

return;
}
 if (antal2 > 0)
 {

     delete[] imgLbl;
     delete[] exifExist;
     delete[] datum;
     delete[] tid;
     delete[] datumTid;
     delete[] exifLbl;
     delete[] checkbox;
     delete[] knapp;
     delete[] knappSet;
     delete[] signalMapper;
     delete[] signalMapper2;
     delete[] signalMapperSet;
     delete containerLabel;
     delete scrollArea;

    imgLbl = new QLabel[1];
    exifExist = new bool[1];
    datum = new QDate[1];
    tid = new QTime[1];
    datumTid = new QDateTime[1];
     exifLbl = new QLabel[1];
     checkbox = new QCheckBox[1];
     knapp = new QPushButton[1];
     knappSet = new QPushButton[1];
     signalMapper = new QSignalMapper[1];
      signalMapper2 = new QSignalMapper[1];
      signalMapperSet = new QSignalMapper[1];
     containerLabel = new QLabel;
     scrollArea = new QScrollArea;


    opna();
 }
 else
 {
     delete fileNames;
     fileNames = new QStringList;
     ui->actionOpenMore->setEnabled(false);
     delete[] imgLbl;
     delete[] exifExist;
     delete[] datum;
     delete[] tid;
     delete[] datumTid;
     delete[] exifLbl;
     delete[] checkbox;
     delete[] knapp;
     delete[] knappSet;
     delete[] signalMapper;
     delete[] signalMapper2;
     delete[] signalMapperSet;
     delete containerLabel;
     delete scrollArea;

     imgLbl = new QLabel[1];
     exifExist = new bool[1];
     datum = new QDate[1];
     tid = new QTime[1];
     datumTid = new QDateTime[1];
     exifLbl = new QLabel[1];
     checkbox = new QCheckBox[1];
     knapp = new QPushButton[1];
     knappSet = new QPushButton[1];
     signalMapper = new QSignalMapper[1];
     signalMapper2 = new QSignalMapper[1];
     signalMapperSet = new QSignalMapper[1];
     containerLabel = new QLabel;
     scrollArea = new QScrollArea;
     ui->progressBar->setValue(0);

 }





}

void MainWindow::closeAllFiles()
{

int antal=fileNames->count();
    if (antal < 2)
            return;

delete fileNames;
fileNames = new QStringList;

ui->actionOpenMore->setEnabled(false);
delete[] imgLbl;
delete[] exifExist;
delete[] datum;
delete[] tid;
delete[] datumTid;
delete[] exifLbl;
delete[] checkbox;
delete[] knapp;
delete[] knappSet;
delete[] signalMapper;
delete[] signalMapper2;
delete[] signalMapperSet;
delete containerLabel;
delete scrollArea;

imgLbl = new QLabel[1];
exifExist = new bool[1];
datum = new QDate[1];
tid = new QTime[1];
datumTid = new QDateTime[1];
exifLbl = new QLabel[1];
checkbox = new QCheckBox[1];
knapp = new QPushButton[1];
knappSet = new QPushButton[1];
signalMapper = new QSignalMapper[1];
 signalMapper2 = new QSignalMapper[1];
 signalMapperSet = new QSignalMapper[1];
containerLabel = new QLabel;
scrollArea = new QScrollArea;

ui->progressBar->setValue(0);

lblStatus->setText(tr("No files loaded"));


}





void MainWindow::opna()
{



int antal = fileNames->count();
antal--;
ui->progressBar->setMinimum(0);

ui->progressBar->setMaximum(antal);




QStringList::iterator it3 = fileNames->begin();
it3++;
int vidd=0, hojd=0;
int under = 0;
std::stringstream ss;



//QMatrix matrix;
//matrix.rotate(270.0); // VNDES



imgLbl = new QLabel[antal];
exifExist = new bool[antal];
exifLbl = new QLabel[antal];
datum = new QDate[antal];
tid = new QTime[antal];
datumTid = new QDateTime[antal];
knapp = new QPushButton[antal];
knappSet = new QPushButton[antal];
checkbox = new QCheckBox[antal];
containerLabel = new QLabel;
QSize storlek;
signalMapper = new QSignalMapper[antal];

signalMapper2 = new QSignalMapper[antal];
signalMapperSet = new QSignalMapper[antal];

Exif *exif;
exif = new Exif;


char *ch = new char[20];
char *filnamn = new char[300];

char *info = new char[50];

QString tmp, tmp2, tmp3;
std::string stmp;
QFont font("Helvetica",10);
QString filnamnstext;
int ingen_exif_info=0;
int dt_1=0, dt_2=0, dt_3=0,dt_raknare=0;
QString dt_tmp;
bool dt_ok=false;

QIcon iconAdjust;
iconAdjust.addFile(QString::fromUtf8(":/images/adjust"), QSize(), QIcon::Normal, QIcon::Off);

QIcon iconEnlarge;
iconEnlarge.addFile(QString::fromUtf8(":/images/enlarge"), QSize(), QIcon::Normal, QIcon::Off);

// LOOPEN
for (int i=0; i<antal; i++)
        {

QImage *skaladImage = new QImage;
//*skaladImage = skaladImage->scaled(storlek,Qt::KeepAspectRatio,Qt::FastTransformation);
QImageReader *imageReader = new QImageReader;
imageReader->setFileName(QDir::toNativeSeparators(*it3));
filnamnstext = *it3;
storlek = imageReader->size();
storlek = skala(storlek,300);


imageReader->setScaledSize(storlek);
*skaladImage = imageReader->read();

int noBilddata = skaladImage->width();





    connect(&knapp[i], SIGNAL(clicked()), &signalMapper[i], SLOT(map()));
    signalMapper[i].setMapping(&knapp[i], i);
    connect(&signalMapper[i], SIGNAL(mapped(const int)), this, SLOT(select(const int)));

    connect(&knappSet[i], SIGNAL(clicked()), &signalMapperSet[i], SLOT(map()));
    signalMapperSet[i].setMapping(&knappSet[i], i);
    connect(&signalMapperSet[i], SIGNAL(mapped(const int)), this, SLOT(set(const int)));

    connect(&checkbox[i], SIGNAL(clicked()), &signalMapper2[i], SLOT(map()));
    signalMapper2[i].setMapping(&checkbox[i], i);
    connect(&signalMapper2[i], SIGNAL(mapped(const int)), this, SLOT(check(const int)));



//*image = image->transformed(matrix,Qt::FastTransformation); // VNDES
//*skaladImage = image->scaled(storlek,Qt::KeepAspectRatio,Qt::FastTransformation);






vidd = storlek.width();
hojd = storlek.height();

if (noBilddata < 1)
{
    imgLbl[i].setStyleSheet("QLabel { background-color: yellow; font-size: 16px  }");
    imgLbl[i].setMargin(15);
    imgLbl[i].setText(tr("Unknown image format"));

    knapp[i].setDisabled(true);

}
else
{

    imgLbl[i].setPixmap(QPixmap::fromImage(*skaladImage));
}

imgLbl[i].setToolTip(filnamnstext);

delete skaladImage;
delete imageReader;


exifLbl[i].setAlignment(Qt::AlignTop);
imgLbl[i].setGeometry(0,under,vidd,hojd);
exifLbl[i].setGeometry(vidd+4,under+100,100,100);

exifLbl[i].setWordWrap(true);
exifLbl[i].setMargin(5);

// exifLbl[i].setStyleSheet("QLabel { background-color: blue; }");
knapp[i].setGeometry(vidd+10,under+5,80,30);
knappSet[i].setGeometry(vidd+10,under+40,80,30);
knapp[i].setText(tr("Enlarge"));
knappSet[i].setText(tr("Set"));
knappSet[i].setIcon(iconAdjust);

knapp[i].setIcon(iconEnlarge);
checkbox[i].setGeometry(vidd+10,under+70,50,30);
imgLbl[i].setParent(containerLabel);
exifLbl[i].setParent(containerLabel);
knapp[i].setParent(containerLabel);
knappSet[i].setParent(containerLabel);
checkbox[i].setParent(containerLabel);



//exifLbl->show();

        it3++;
        under=under+hojd+5;

        ui->progressBar->setValue(i+1);


        tmp = fileNames->at(i+1);
//QMessageBox::critical(this, APPLICATION_NAME+" "+VERSION,tmp);
stmp=tmp.toStdString();
   strcpy(filnamn,stmp.c_str());
QString qs_info;
exifLbl[i].setFont(font);

        if (! exif->getExif(filnamn,ch,info) )
            {
//QMessageBox::critical(this, APPLICATION_NAME+" "+VERSION,"FUNKAR");


                qs_info = QString::fromLatin1(info);

                qs_info=qs_info.mid(0,19);
               // te_disp->append(QDir::toNativeSeparators("<font color=red>"+s+stripNames(constIterator)+"</font>"));
                //QMessageBox::critical(this, APPLICATION_NAME+" "+VERSION,QDir::toNativeSeparators("<font color=red>"+s+stripNames(constIterator)+"</font>"));
//QMessageBox::critical(this, APPLICATION_NAME+" "+VERSION,QDir::toNativeSeparators("<font color=red>"+qs_info+"</font>"));

                exifLbl[i].setText(qs_info);
                checkbox[i].setChecked(true);
                //continue;
                ingen_exif_info++;
knappSet[i].setDisabled(true);
exifExist[i]=false;
            }

        else
        {
        tmp=QString::fromLatin1(ch);
        tmp=tmp.trimmed();
        tmp=tmp.left(19);
        tmp2=tmp.left(10);
        tmp3=tmp.right(8);
        exifLbl[i].setText(tmp2+"\n"+tmp3);
        exifExist[i]=true;


        // Skicka datum och tid fr justering
        dt_tmp=tmp2.mid(0,4);
      //  QMessageBox::information(this, APPLICATION_NAME+" "+VERSION,dt_tmp);
        dt_1=dt_tmp.toInt(&dt_ok,10);
        if (dt_ok)
            dt_raknare++;

        dt_tmp=tmp2.mid(5,2);
       // QMessageBox::information(this, APPLICATION_NAME+" "+VERSION,dt_tmp);
        dt_2=dt_tmp.toInt(&dt_ok,10);
        if (dt_ok)
            dt_raknare++;

        dt_tmp=tmp2.mid(8,2);
      //  QMessageBox::information(this, APPLICATION_NAME+" "+VERSION,dt_tmp);
        dt_3=dt_tmp.toInt(&dt_ok,10);
        if (dt_ok)
            dt_raknare++;



        if (dt_raknare==3)
                 datum[i].setDate(dt_1,dt_2,dt_3);


        dt_raknare=0;
        dt_tmp=tmp3.mid(0,2);
      //  QMessageBox::information(this, APPLICATION_NAME+" "+VERSION,dt_tmp);
        dt_1=dt_tmp.toInt(&dt_ok,10);
        if (dt_ok)
            dt_raknare++;

        dt_tmp=tmp3.mid(3,2);
      //  QMessageBox::information(this, APPLICATION_NAME+" "+VERSION,dt_tmp);
        dt_2=dt_tmp.toInt(&dt_ok,10);
        if (dt_ok)
            dt_raknare++;

        dt_tmp=tmp3.mid(6,2);
      //  QMessageBox::information(this, APPLICATION_NAME+" "+VERSION,dt_tmp);
        dt_3=dt_tmp.toInt(&dt_ok,10);
        if (dt_ok)
            dt_raknare++;

        if (dt_raknare==3)
                 tid[i].setHMS(dt_1,dt_2,dt_3);

        dt_raknare=0;
        }


datumTid[i].setDate(datum[i]);
datumTid[i].setTime(tid[i]);
        }
delete exif;
if (ingen_exif_info>0)
{


    if (ingen_exif_info > 1)
    {
        QString s;
        s.setNum(ingen_exif_info);

        QMessageBox::information(this, APPLICATION_NAME " " VERSION,s+tr(" pictures without exif data was found.\nYou can close them by clicking\n\"Close selected files\"."));

    }
    else
    {

        QMessageBox::information(this, APPLICATION_NAME " " VERSION,tr("A picture without exif data was found.\nYou can close it by clicking\n\"Close selected files\"."));

    }


}



containerLabel->setFixedSize(400,under+10);
//containerLabel->setStyleSheet("QLabel { background-color: black; }");
scrollArea = new QScrollArea(this);


scrollArea->setWidget(containerLabel);

if (ui->mainToolBar->isHidden())
    // Windows
    // scrollArea->setGeometry(1,69,430,*xmax-169);
    // Linux
       scrollArea->setGeometry(1,75,430,*xmax-175);
else
{
    // Windows
    // scrollArea->setGeometry(1,105,430,*xmax-205);
    // Linux
       scrollArea->setGeometry(1,113,430,*xmax-213);
}

scrollArea->show();

QString s_antal;
s_antal=QString("%1").arg(antal);

if (antal > 1)
{
    lblStatus->setText(s_antal + tr(" loaded files"));
}
else
{
    lblStatus->setText(s_antal + tr(" loaded file"));
}



}


void MainWindow::selectAll()
{


    int antal = fileNames->count();
    antal--;
    for (int i=0; i<antal; i++)
       checkbox[i].setChecked(true);



}

void MainWindow::deSelectAll()
{


    int antal = fileNames->count();
    antal--;
    for (int i=0; i<antal; i++)
       checkbox[i].setChecked(false);



}

void MainWindow::swedish()
{

QString conf_file_name = QDir::toNativeSeparators("/"PROG_NAME".conf");
k = new Config(conf_file_name);
std::string s = k->getConf("language");

if (s != "sv_SE")
{
k->setConf("language","sv_SE");
QMessageBox::information(this, APPLICATION_NAME " " VERSION,tr("You must restart the application before the language change takes effect."));
}
delete k;
}

void MainWindow::english()
{


    QString conf_file_name = QDir::toNativeSeparators("/"PROG_NAME".conf");
    k = new Config(conf_file_name);
    std::string s = k->getConf("language");

    if (s != "en_US")
    {
    k->setConf("language","en_US");
    QMessageBox::information(this, APPLICATION_NAME " " VERSION,tr("You must restart the application before the language change takes effect."));
    }
    delete k;
}

void MainWindow::russian()
{


    QString conf_file_name = QDir::toNativeSeparators("/"PROG_NAME".conf");
    k = new Config(conf_file_name);
    std::string s = k->getConf("language");

    if (s != "ru_RU")
    {
    k->setConf("language","ru_RU");
    QMessageBox::information(this, APPLICATION_NAME " " VERSION,tr("You must restart the application before the language change takes effect."));
    }
    delete k;
}

void MainWindow::greek()
{


    QString conf_file_name = QDir::toNativeSeparators("/"PROG_NAME".conf");
    k = new Config(conf_file_name);
    std::string s = k->getConf("language");

    if (s != "el_GR")
    {
    k->setConf("language","el_GR");
    QMessageBox::information(this, APPLICATION_NAME " " VERSION,tr("You must restart the application before the language change takes effect."));
    }
    delete k;
}

void MainWindow::open2(bool mer)
{



    QString conf_file_name = QDir::toNativeSeparators("/"PROG_NAME".conf");
    k = new Config(conf_file_name);
    QString sokvag;
    std::string s = k->getConf("open_path");
    QString qs = QString::fromStdString(s);

    QFileInfo info(qs);
     if (info.isReadable())
           sokvag = qs;
     else
     {
         sokvag = QDir::homePath();
     }

    if (mer)
     inputFileDialog = new QFileDialog(this, tr("Open more files (the old files will remain open)"),sokvag);
    else
     inputFileDialog = new QFileDialog(this, tr("Open File"),sokvag);

     inputFileDialog->setFileMode(QFileDialog::ExistingFiles);
     inputFileDialog->setAcceptMode(QFileDialog::AcceptOpen);



    inputFileDialog->setLabelText(QFileDialog::LookIn,tr("Look in:"));
    inputFileDialog->setLabelText(QFileDialog::FileName,tr("File name:"));
    inputFileDialog->setLabelText(QFileDialog::FileType,tr("Files of type:"));

    QList<QByteArray>list = QImageReader::supportedImageFormats();
    QList<QByteArray>::const_iterator li;
    QStringList filters;
    for (li = list.constBegin(); li != list.constEnd(); ++li)
    {
    filters << "*."+*li;

    }
    filters << "*.*";



   inputFileDialog->setFilters(filters);
   std::string default_filter = k->getConf("current_filter");
   inputFileDialog->selectNameFilter(QString::fromStdString(default_filter));
   inputFileDialog->setViewMode(QFileDialog::Detail);




     if (inputFileDialog->exec())
     {


         delete[] imgLbl;
         delete[] exifExist;
         delete[] datum;
         delete[] tid;
         delete[] datumTid;
         delete[] exifLbl;
         delete[] checkbox;
         delete[] knapp;
         delete[] knappSet;
         delete[] signalMapper;
         delete[] signalMapper2;
         delete[] signalMapperSet;
         delete containerLabel;
         delete scrollArea;


         int antal=0;
         QDir dir;
         dir = inputFileDialog->directory();
         QString directoryName = dir.path();
         QFileInfo info2(directoryName);

         if (! info2.isReadable() )
         {
             QMessageBox::critical(this, APPLICATION_NAME " " VERSION,tr("You do not have enough permissions to read\n")+directoryName);
             delete k;
             return;
         }



         if (mer)
         {
              antal++;
             *fileNames << inputFileDialog->selectedFiles();
              QString s;
              int i = fileNames->removeDuplicates();
              if (i>0)
              {
              s.setNum(i);
              if (i==1)
                QMessageBox::information(this, APPLICATION_NAME " " VERSION,tr("One of the new files were already open, it will not be reopened."));
              if (i>1)
                QMessageBox::information(this, APPLICATION_NAME " " VERSION,s+tr(" of the new files were already opened, they will not be reopened."));
              }


         }
         else
         {
            antal++;
             delete fileNames;
             fileNames=new QStringList;
             *fileNames << "STOP";
             *fileNames << inputFileDialog->selectedFiles();


         }







         QString qs_qurrent_extension = inputFileDialog->selectedNameFilter();

         k->setConf("open_path",directoryName.toStdString());
         k->setConf("current_filter",qs_qurrent_extension.toStdString());

delete k;
ui->actionOpenMore->setEnabled(true);


         opna();

     }



}

QSize MainWindow::skala(QSize storlek, float biggest)
{
    int w = storlek.width();
    int h = storlek.height();
    QSize nyStorlek;
    float f;
    if ( w > h)
    {
        f = (float) w / (float) h;
        nyStorlek.setWidth(biggest);
        nyStorlek.setHeight(biggest / f);
        return nyStorlek;
    }
    if ( w < h)
    {
        f = (float) h / (float) w;
        nyStorlek.setWidth(biggest / f);
        nyStorlek.setHeight(biggest);
        return nyStorlek;
    }
    else
    {
        nyStorlek.setWidth(biggest);
        nyStorlek.setHeight(biggest);
        return nyStorlek;
    }
}

QSize MainWindow::skala(QSize storlek, int biggest)
{
    int w = storlek.width();
    int h = storlek.height();
    QSize nyStorlek;
    float f;
    if ( w > h)
    {
        f = (float) w / (float) h;
        nyStorlek.setWidth(biggest);
        nyStorlek.setHeight(biggest / f);
        return nyStorlek;
    }
    if ( w < h)
    {
        f = (float) h / (float) w;
        nyStorlek.setWidth(biggest / f);
        nyStorlek.setHeight(biggest);
        return nyStorlek;
    }
    else
    {
        nyStorlek.setWidth(biggest);
        nyStorlek.setHeight(biggest);
        return nyStorlek;
    }
}


// PROTECTED
/*
// RESIZE EVENT
void MainWindow::resizeEvent(QResizeEvent * event)
{

     //   QSize z = bigImageWidget->size();
    //   bigLbl->setGeometry(100,100,z.width(),z.height());
QMessageBox::information(this, APPLICATION_NAME+" "+VERSION,"XXX");
}
*/
bool MainWindow::getOffset(QString &sec_in, QString &d, QString &h, QString &min, QString &s)
{
qint64 day, houer, minut, second;
qint64 tmp, tmp2, tmp3;
qint64 in = sec_in.toLongLong();

tmp = in % 86400;
day = in / 86400;


tmp2 = tmp % 3600; // sekunder per timme
houer = tmp / 3600;

tmp3 = tmp2 % 60; // sekunder per minut
minut = tmp2 / 60;


second = tmp3;

d.setNum(day);
h.setNum(houer);
min.setNum(minut);
s.setNum(second);

return true;

}

void MainWindow::displayOffset(std::string stds_offset)
{


    if (stds_offset != "0")
    {

        QString qs_initiera = QString::fromStdString(stds_offset);

        QString d, h, min, s;
        bool lyckas;
        qint64 qint_initiera = qs_initiera.toLongLong();
       lyckas =  getOffset(qs_initiera, d, h, min, s);


       if (lyckas)
       {
          //ui->lblAdjustment->setText(tr(" Current offset: D: ")+d+tr(", H: ")+h+tr(", M: ")+min+tr(", S: ")+s );
           int id = d.toInt();
           int ih = h.toInt();
           int imin = min.toInt();
           int is = s.toInt();

          if (qint_initiera < 0)
           {
             id=abs(id);
             ih=abs(ih);
             imin=abs(imin);
             is=abs(is);

             d=d.setNum(id);
             h=h.setNum(ih);
             min=min.setNum(imin);
             s=s.setNum(is);


            if (id == 0)
                ui->lblAdjustment->setText(tr("Current offset: - ")+h+":"+min+":"+s+tr(" (h:m:s)"));
            if (id == 1)
             ui->lblAdjustment->setText(tr("Current offset: - ")+d+tr(" Day and ")+h+":"+min+":"+s+tr(" (h:m:s)"));
            if (id > 1)
             ui->lblAdjustment->setText(tr("Current offset: - ")+d+tr(" Days and ")+h+":"+min+":"+s+tr(" (h:m:s)"));
          }

          if (qint_initiera > 0)
           {


              if (id == 0)
                  ui->lblAdjustment->setText(tr("Current offset: + ")+h+":"+min+":"+s+tr(" (h:m:s)"));
              if (id == 1)
               ui->lblAdjustment->setText(tr("Current offset: + ")+d+tr(" Day and ")+h+":"+min+":"+s+tr(" (h:m:s)"));
              if (id > 1)
               ui->lblAdjustment->setText(tr("Current offset: + ")+d+tr(" Days and ")+h+":"+min+":"+s+tr(" (h:m:s)"));
          }



        }
      else

          QMessageBox::critical(this, APPLICATION_NAME " " VERSION,tr("No offset was calculated"));






    }
    else
       ui->lblAdjustment->setText(tr("Current offset: None"));







}
