/*
    EXIF ReGenerate
    Copyright (C) 2010 - 2011 Ingemar Ceicer
    http://ceicer.org/ingemar/
    programmering1 (at) ceicer (dot) org

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
*/

#include "settime.h"
#include "ui_settime.h"
#include "mainwindow.h"

Settime::Settime(QWidget *parent) :
    QDialog(parent),
    ui(new Ui::Settime)
{
    ui->setupUi(this);
}

Settime::Settime(QString s, QDate datum, QTime tid)
{
ui->setupUi(this);
    actionSetDT = new QAction(tr("Adjust"),this);
    actionSetUndo = new QAction(tr("Undo"),this);
    this->setContextMenuPolicy( Qt::ActionsContextMenu );
    this->addAction( actionSetDT );
    this->addAction( actionSetUndo );




    std::stringstream ss;
    QString conf_file_name = QDir::toNativeSeparators("/"PROG_NAME".conf");
    k = new Config(conf_file_name);
    std::string sy = k->getConf("ys_lage");
    std::string sx = k->getConf("xs_lage");
    delete k;
    int iy=0, ix=0;

    ss.clear();
    ss << sy;
    ss >> iy;

    ss.clear();
    ss << sx;
    ss >> ix;

    dt_old = new QDateTime;
    dt_old->setDate(datum);
    dt_old->setTime(tid);

const int ymax(QApplication::desktop()->height());
  if (iy > (ymax-50))
  {
       iy=200;
       ix=200;
   }


 const int xmax(QApplication::desktop()->width());

   if (ix > (xmax-50))
  {
       ix=200;
       iy=200;
   }

this->setGeometry(ix,iy,470,300);
this->setFixedSize(470,300);
imageLbl = new  QLabel(this);
imageLbl->setGeometry(0,0,300,300);
imageLbl->setFixedSize(300,300);

QFont font("Helvetica",10);

QImageReader imageReader;
imageReader.setFileName(QDir::toNativeSeparators(s));
QSize storlek = imageReader.size();
storlek = MainWindow::skala(storlek,300);


imageReader.setScaledSize(storlek);

QImage skaladImage = imageReader.read();
int noBilddata = skaladImage.width();



if (noBilddata < 1)
{
    imageLbl->setStyleSheet("QLabel { background-color: yellow; font-size: 16px  }");
    imageLbl->setMargin(15);
    imageLbl->setText(tr("Unknown image format"));


}
else
{
imageLbl->setPixmap(QPixmap::fromImage(skaladImage));

}

Exif *exif;
exif = new Exif;
char *ch = new char[20];
char *filnamn = new char[300];
char *info = new char[50];
std::string stmp;
stmp=s.toStdString();
strcpy(filnamn,stmp.c_str());

QDate savedDate;
QTime savedTime;

if (! exif->getExif(filnamn,ch,info) )
{

QString qs_info = QString::fromLatin1(info);
QMessageBox::critical(this, APPLICATION_NAME " " VERSION,qs_info);


}
else
{
    int dt_1=0, dt_2=0, dt_3=0,dt_raknare=0;
    QString tmp, tmp2, tmp3;
    QString dt_tmp;
    bool dt_ok=false;

    tmp=QString::fromLatin1(ch);
    tmp=tmp.trimmed();
    tmp=tmp.left(19);
    tmp2=tmp.left(10);
    tmp3=tmp.right(8);

    // Skicka datum och tid för justering
    dt_tmp=tmp2.mid(0,4);
  //  QMessageBox::information(this, APPLICATION_NAME+" "+VERSION,dt_tmp);
    dt_1=dt_tmp.toInt(&dt_ok,10);
    if (dt_ok)
        dt_raknare++;

    dt_tmp=tmp2.mid(5,2);
   // QMessageBox::information(this, APPLICATION_NAME+" "+VERSION,dt_tmp);
    dt_2=dt_tmp.toInt(&dt_ok,10);
    if (dt_ok)
        dt_raknare++;

    dt_tmp=tmp2.mid(8,2);
  //  QMessageBox::information(this, APPLICATION_NAME+" "+VERSION,dt_tmp);
    dt_3=dt_tmp.toInt(&dt_ok,10);
    if (dt_ok)
        dt_raknare++;



    if (dt_raknare==3)
             savedDate.setDate(dt_1,dt_2,dt_3);


    dt_raknare=0;
    dt_tmp=tmp3.mid(0,2);
  //  QMessageBox::information(this, APPLICATION_NAME+" "+VERSION,dt_tmp);
    dt_1=dt_tmp.toInt(&dt_ok,10);
    if (dt_ok)
        dt_raknare++;

    dt_tmp=tmp3.mid(3,2);
  //  QMessageBox::information(this, APPLICATION_NAME+" "+VERSION,dt_tmp);
    dt_2=dt_tmp.toInt(&dt_ok,10);
    if (dt_ok)
        dt_raknare++;

    dt_tmp=tmp3.mid(6,2);
  //  QMessageBox::information(this, APPLICATION_NAME+" "+VERSION,dt_tmp);
    dt_3=dt_tmp.toInt(&dt_ok,10);
    if (dt_ok)
        dt_raknare++;

    if (dt_raknare==3)
            savedTime.setHMS(dt_1,dt_2,dt_3);

    dt_raknare=0;

delete exif;



}



 imageLbl->setToolTip(s);
 imageLbl->setWhatsThis(s);

dateedit = new QDateEdit(this);
dateedit->setFont(font);
dateedit->setGeometry(330,10,130,24);
QString tmp, tmp2;
const QString visaDateedit(tr("Set date from ")+tmp.setNum(START_YEAR)+"-01-01 "+tr("to ")+tmp2.setNum(STOP_YEAR)+"-12-31");
dateedit->setWhatsThis(visaDateedit);

const QDate dateMin(START_YEAR,1,1);
const QDate dateMax(STOP_YEAR,12,31);
dateedit->setMaximumDate(dateMax);
dateedit->setMinimumDate(dateMin);
//dateedit->setDate(datum);
dateedit->setDate(savedDate);
dateedit->setDisplayFormat("yyyy-MM-dd");

timeedit = new QTimeEdit(this);
const QString visaTimeedit(tr("Set date from ")+tmp.setNum(START_YEAR)+"-01-01 00:00:00 "+tr("to ")+tmp2.setNum(STOP_YEAR)+"-12-31 23:59:59");
timeedit->setFont(font);
timeedit->setGeometry(330,36,130,24);
timeedit->setWhatsThis(visaTimeedit);
//timeedit->setTime(tid);
timeedit->setTime(savedTime);
timeedit->setDisplayFormat("hh:mm:ss");

ok = new QPushButton(this);
ok->setGeometry(330,74,130,30);
// ok->setGeometry(330,74,100,30);
ok->setText(tr("Adjust"));

QIcon iconOk;
iconOk.addFile(QString::fromUtf8(":/images/apply"), QSize(), QIcon::Normal, QIcon::Off);
ok->setIcon(iconOk);

undo = new QPushButton(this);
undo->setGeometry(330,109,130,30);
//undo->setGeometry(330,109,100,30);
undo->setText(tr("Undo"));

QIcon iconUndo;
iconUndo.addFile(QString::fromUtf8(":/images/undo"), QSize(), QIcon::Normal, QIcon::Off);
undo->setIcon(iconUndo);

stang = new QPushButton(this);
stang->setGeometry(380,262,80,30);
stang->setText(tr("Close"));

QIcon iconStang;
iconStang.addFile(QString::fromUtf8(":/images/exit"), QSize(), QIcon::Normal, QIcon::Off);
stang->setIcon(iconStang);



if ( (dt_old->time() == savedTime) && (dt_old->date() == savedDate) )
{
    undo->setDisabled(true);
    undo->setText(tr("Can't undo"));
    actionSetUndo->setDisabled(true);
    actionSetUndo->setText(tr("Can't undo"));
}
else
{
    undo->setEnabled(true);
    undo->setText(tr("Undo"));
    actionSetUndo->setEnabled(true);
    actionSetUndo->setText(tr("Undo"));
}




    // Windows
    // int last = s.lastIndexOf('\\');
    // Linux
       int last = s.lastIndexOf('/');
    int langd = s.size();
    QString qinfo = s.right(langd-(last+1));
    setWindowTitle(qinfo);

 connect(ok, SIGNAL(clicked()), this, SLOT(setDT()));
 connect(actionSetDT, SIGNAL(triggered()), this, SLOT(setDT()));
 connect(undo, SIGNAL(clicked()), this, SLOT(setUndo()));
 connect(actionSetUndo, SIGNAL(triggered()), this, SLOT(setUndo()));
 connect(stang, SIGNAL(clicked()), this, SLOT(stang_()));


}

Settime::~Settime()
{
//QMessageBox::information(this, APPLICATION_NAME+" "+VERSION,"XXXX");
    QString conf_file_name = QDir::toNativeSeparators("/"PROG_NAME".conf");
    k = new Config(conf_file_name);

    QRect rect;
    rect=this->geometry();

  int ix = rect.x();
  int iy = rect.y();



   std::stringstream ss;
   std::string str;

   ss.clear();
   ss << ix;
   ss >> str;
   k->setConf("xs_lage",str);

   ss.clear();
   ss << iy;
   ss >> str;
   k->setConf("ys_lage",str);
   delete k;
/*
   QString oy, ox;
   oy.setNum(iy);
   ox.setNum(ix);
    QMessageBox::information(this, APPLICATION_NAME+" "+VERSION,"y="+oy+" x="+ox);
*/

   delete imageLbl;
   delete dateedit;
   delete timeedit;
   delete dt_old;
  // delete dt_new;
   delete ok;
   delete stang;
   //delete ui;
}
 // SLOTS

void Settime::setUndo()
{
dateedit->setDate(dt_old->date());
timeedit->setTime(dt_old->time());
}

void Settime::setDT()
{
QString conf_file_name = QDir::toNativeSeparators("/"PROG_NAME".conf");
QDateTime *dt_new;
dt_new = new QDateTime;
dt_new->setDate(dateedit->date());
dt_new->setTime(timeedit->time());

qint64 offset;
//qint64 old, ny;

//old = dt_old->toMSecsSinceEpoch();
//ny = dt_new->toMSecsSinceEpoch();
//offset = ny-old;
const QDateTime *tmp = dt_new;
offset = dt_old->secsTo(*tmp);

//QString S;
//S.setNum(offset);
 //QMessageBox::information(this, APPLICATION_NAME+" "+VERSION,S);



std::stringstream ss;
std::string s;
ss.clear();
ss << offset;
ss >> s;


k = new Config(conf_file_name);
k->setConf("offset",s);
delete k;

delete dt_new;

}


void Settime::stang_()
{

delete this;


}


void Settime::closeEvent(QCloseEvent * event)
{



delete this;

}

